ChangeSet 1.793, 2002/12/05 14:21:57-08:00, tvrtko@net4u.hr

[PATCH] usb-uhci, fixed memory leak with one-shot interrupt transfers

Credit goes to Georg Acher for the fix. I only reported the leak, and did the
pre&post testing. Tested under 2.4.18 and 2.4.19.


diff -Nru a/drivers/usb/usb-uhci.c b/drivers/usb/usb-uhci.c
--- a/drivers/usb/usb-uhci.c	Thu Dec  5 14:48:23 2002
+++ b/drivers/usb/usb-uhci.c	Thu Dec  5 14:48:23 2002
@@ -2514,6 +2514,7 @@
 			}
 			else {
 				uhci_unlink_urb_async(s, urb, UNLINK_ASYNC_STORE_URB);
+				uhci_clean_iso_step2(s, urb_priv);
 				// correct toggle after unlink
 				usb_dotoggle (urb->dev, usb_pipeendpoint (urb->pipe), usb_pipeout (urb->pipe));
 				clr_td_ioc(desc); // inactivate TD
